function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import classNames from 'classnames';
import './index.less';
var clsPrefix = 'osui-highlight-text';

var breakWordsByMark = function breakWordsByMark(input, mark, props) {
  var className = props && props.className || '';

  if (typeof input !== 'string' || typeof mark !== 'string') {
    return input;
  }

  var parts = input.split(new RegExp("(".concat(mark, ")"), 'gi'));
  return parts.map(function (part, index) {
    if (!part) {
      return null;
    }

    if (part.toLowerCase() === mark.toLowerCase()) {
      return /*#__PURE__*/React.createElement("span", _objectSpread(_objectSpread({
        // eslint-disable-next-line react/no-array-index-key
        key: "".concat(part, "-").concat(index)
      }, props), {}, {
        className: classNames("".concat(clsPrefix, "-mark"), className)
      }), part);
    } else {
      return part;
    }
  });
};

var HighlightText = function HighlightText(_ref) {
  var children = _ref.children,
      mark = _ref.mark,
      markProps = _ref.markProps;

  var _React$useState = React.useState(children),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      text = _React$useState2[0],
      setText = _React$useState2[1];

  React.useLayoutEffect(function () {
    var requestId = window.requestAnimationFrame(function () {
      setText(breakWordsByMark(children, mark, markProps));
    });
    return function () {
      window.cancelAnimationFrame(requestId);
    };
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  [children, mark]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, text);
};

export default HighlightText;
//# sourceMappingURL=index.js.map